package com.ibiz5.app.core.sample.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import com.ibiz5.app.util.domain.EntityBase;
import com.ibiz5.app.util.annotation.DEField;
import com.ibiz5.app.util.enums.DEPredefinedFieldType;
import com.ibiz5.app.util.enums.DEFieldDefaultValueType;
import com.ibiz5.app.util.helper.DataObject;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;
import com.ibiz5.app.util.annotation.Audit;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import com.ibiz5.app.util.domain.EntityMP;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;

/**
 * 实体[账户]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "T_IBZ5ACCOUNT",resultMap = "IBZ5AccountResultMap")
public class IBZ5Account extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 建立人
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * 开户银行号
     */
    @TableField(value = "bankaccountnum")
    @JSONField(name = "bankaccountnum")
    @JsonProperty("bankaccountnum")
    private String bankaccountnum;
    /**
     * 更新时间
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * 账户名称
     */
    @TableField(value = "ibz5accountname")
    @JSONField(name = "ibz5accountname")
    @JsonProperty("ibz5accountname")
    private String ibz5accountname;
    /**
     * 更新人
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * 开户行
     */
    @TableField(value = "bankname")
    @JSONField(name = "bankname")
    @JsonProperty("bankname")
    private String bankname;
    /**
     * 建立时间
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * 账户标识
     */
    @DEField(isKeyField=true)
    @TableId(value= "ibz5accountid",type=IdType.ASSIGN_UUID)
    @JSONField(name = "ibz5accountid")
    @JsonProperty("ibz5accountid")
    private String ibz5accountid;



    /**
     * 设置 [开户银行号]
     */
    public void setBankaccountnum(String bankaccountnum){
        this.bankaccountnum = bankaccountnum ;
        this.modify("bankaccountnum",bankaccountnum);
    }

    /**
     * 设置 [账户名称]
     */
    public void setIbz5accountname(String ibz5accountname){
        this.ibz5accountname = ibz5accountname ;
        this.modify("ibz5accountname",ibz5accountname);
    }

    /**
     * 设置 [开户行]
     */
    public void setBankname(String bankname){
        this.bankname = bankname ;
        this.modify("bankname",bankname);
    }


    /**
     * 复制当前对象数据到目标对象(粘贴重置)
     * @param targetEntity 目标数据对象
     * @param bIncEmpty  是否包括空值
     * @param <T>
     * @return
     */
    @Override
    public <T> T copyTo(T targetEntity, boolean bIncEmpty) {
        this.reset("ibz5accountid");
        return super.copyTo(targetEntity,bIncEmpty);
    }
}


