package com.ibiz5.app.core.sample.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import com.ibiz5.app.util.domain.EntityBase;
import com.ibiz5.app.util.annotation.DEField;
import com.ibiz5.app.util.enums.DEPredefinedFieldType;
import com.ibiz5.app.util.enums.DEFieldDefaultValueType;
import com.ibiz5.app.util.helper.DataObject;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;
import com.ibiz5.app.util.annotation.Audit;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import com.ibiz5.app.util.domain.EntityMP;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;

/**
 * 实体[客户]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "T_IBZ5CUSTOMER",resultMap = "IBZ5CustomerResultMap")
public class IBZ5Customer extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 客户名称
     */
    @TableField(value = "ibz5customername")
    @JSONField(name = "ibz5customername")
    @JsonProperty("ibz5customername")
    private String ibz5customername;
    /**
     * 客户编号
     */
    @TableField(value = "customeruid")
    @JSONField(name = "customeruid")
    @JsonProperty("customeruid")
    private String customeruid;
    /**
     * 更新时间
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * 客户编号
     */
    @TableField(value = "sn")
    @JSONField(name = "sn")
    @JsonProperty("sn")
    private String sn;
    /**
     * 更新人
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * 公司地址
     */
    @TableField(value = "address")
    @JSONField(name = "address")
    @JsonProperty("address")
    private String address;
    /**
     * 建立时间
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * 建立人
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * 客户标识
     */
    @DEField(isKeyField=true)
    @TableId(value= "ibz5customerid",type=IdType.ASSIGN_UUID)
    @JSONField(name = "ibz5customerid")
    @JsonProperty("ibz5customerid")
    private String ibz5customerid;



    /**
     * 设置 [客户名称]
     */
    public void setIbz5customername(String ibz5customername){
        this.ibz5customername = ibz5customername ;
        this.modify("ibz5customername",ibz5customername);
    }

    /**
     * 设置 [客户编号]
     */
    public void setCustomeruid(String customeruid){
        this.customeruid = customeruid ;
        this.modify("customeruid",customeruid);
    }

    /**
     * 设置 [客户编号]
     */
    public void setSn(String sn){
        this.sn = sn ;
        this.modify("sn",sn);
    }

    /**
     * 设置 [公司地址]
     */
    public void setAddress(String address){
        this.address = address ;
        this.modify("address",address);
    }


    /**
     * 复制当前对象数据到目标对象(粘贴重置)
     * @param targetEntity 目标数据对象
     * @param bIncEmpty  是否包括空值
     * @param <T>
     * @return
     */
    @Override
    public <T> T copyTo(T targetEntity, boolean bIncEmpty) {
        this.reset("ibz5customerid");
        return super.copyTo(targetEntity,bIncEmpty);
    }
}


