package com.ibiz5.app.core.sample.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import com.ibiz5.app.util.domain.EntityBase;
import com.ibiz5.app.util.annotation.DEField;
import com.ibiz5.app.util.enums.DEPredefinedFieldType;
import com.ibiz5.app.util.enums.DEFieldDefaultValueType;
import com.ibiz5.app.util.helper.DataObject;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;
import com.ibiz5.app.util.annotation.Audit;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import com.ibiz5.app.util.domain.EntityMP;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;

/**
 * 实体[客户管理]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "",resultMap = "IBZ5CustomerMGResultMap")
public class IBZ5CustomerMG extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 客户编号
     */
    @TableField(exist = false)
    @JSONField(name = "customeruid")
    @JsonProperty("customeruid")
    private String customeruid;
    /**
     * 开户行
     */
    @TableField(exist = false)
    @JSONField(name = "bankname")
    @JsonProperty("bankname")
    private String bankname;
    /**
     * 公司地址
     */
    @TableField(exist = false)
    @JSONField(name = "address")
    @JsonProperty("address")
    private String address;
    /**
     * 客户标识
     */
    @DEField(isKeyField=true)
    @TableField(exist = false)
    @JSONField(name = "ibz5customerid")
    @JsonProperty("ibz5customerid")
    private String ibz5customerid;
    /**
     * 客户名称
     */
    @TableField(exist = false)
    @JSONField(name = "ibz5customername")
    @JsonProperty("ibz5customername")
    private String ibz5customername;
    /**
     * 开户银行号
     */
    @TableField(exist = false)
    @JSONField(name = "bankaccountnum")
    @JsonProperty("bankaccountnum")
    private String bankaccountnum;




    /**
     * 复制当前对象数据到目标对象(粘贴重置)
     * @param targetEntity 目标数据对象
     * @param bIncEmpty  是否包括空值
     * @param <T>
     * @return
     */
    @Override
    public <T> T copyTo(T targetEntity, boolean bIncEmpty) {
        this.reset("ibz5customerid");
        return super.copyTo(targetEntity,bIncEmpty);
    }
}


