package com.ibiz5.app.core.sample.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import com.ibiz5.app.util.domain.EntityBase;
import com.ibiz5.app.util.annotation.DEField;
import com.ibiz5.app.util.enums.DEPredefinedFieldType;
import com.ibiz5.app.util.enums.DEFieldDefaultValueType;
import com.ibiz5.app.util.helper.DataObject;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;
import com.ibiz5.app.util.annotation.Audit;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import com.ibiz5.app.util.domain.EntityMP;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;

/**
 * 实体[请假]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "T_IBZ5QJ",resultMap = "IBZ5QJResultMap")
public class IBZ5QJ extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 请假天数
     */
    @TableField(value = "qjts")
    @JSONField(name = "qjts")
    @JsonProperty("qjts")
    private Integer qjts;
    /**
     * 建立人
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * 请假标识
     */
    @DEField(isKeyField=true)
    @TableId(value= "ibz5qjid",type=IdType.ASSIGN_UUID)
    @JSONField(name = "ibz5qjid")
    @JsonProperty("ibz5qjid")
    private String ibz5qjid;
    /**
     * 建立时间
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * 请假名称
     */
    @TableField(value = "ibz5qjname")
    @JSONField(name = "ibz5qjname")
    @JsonProperty("ibz5qjname")
    private String ibz5qjname;
    /**
     * 剩余请假天数
     */
    @DEField(defaultValue = "10")
    @TableField(value = "syqjts")
    @JSONField(name = "syqjts")
    @JsonProperty("syqjts")
    private Integer syqjts;
    /**
     * 更新时间
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * 更新人
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;



    /**
     * 设置 [请假天数]
     */
    public void setQjts(Integer qjts){
        this.qjts = qjts ;
        this.modify("qjts",qjts);
    }

    /**
     * 设置 [请假名称]
     */
    public void setIbz5qjname(String ibz5qjname){
        this.ibz5qjname = ibz5qjname ;
        this.modify("ibz5qjname",ibz5qjname);
    }

    /**
     * 设置 [剩余请假天数]
     */
    public void setSyqjts(Integer syqjts){
        this.syqjts = syqjts ;
        this.modify("syqjts",syqjts);
    }


    /**
     * 复制当前对象数据到目标对象(粘贴重置)
     * @param targetEntity 目标数据对象
     * @param bIncEmpty  是否包括空值
     * @param <T>
     * @return
     */
    @Override
    public <T> T copyTo(T targetEntity, boolean bIncEmpty) {
        this.reset("ibz5qjid");
        return super.copyTo(targetEntity,bIncEmpty);
    }
}


