package com.ibiz5.app.core.sample.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import com.ibiz5.app.util.domain.EntityBase;
import com.ibiz5.app.util.annotation.DEField;
import com.ibiz5.app.util.enums.DEPredefinedFieldType;
import com.ibiz5.app.util.enums.DEFieldDefaultValueType;
import com.ibiz5.app.util.helper.DataObject;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;
import com.ibiz5.app.util.annotation.Audit;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import com.ibiz5.app.util.domain.EntityMP;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;

/**
 * 实体[示例实体03]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "T_IBZ5SAMPLE0003",resultMap = "IBZ5Sample0003ResultMap")
public class IBZ5Sample0003 extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * FIELD01
     */
    @TableField(value = "field01")
    @JSONField(name = "field01")
    @JsonProperty("field01")
    private String field01;
    /**
     * 备注
     */
    @TableField(value = "memo")
    @JSONField(name = "memo")
    @JsonProperty("memo")
    private String memo;
    /**
     * 名称
     */
    @TableField(value = "ibz5sample0003name")
    @JSONField(name = "ibz5sample0003name")
    @JsonProperty("ibz5sample0003name")
    private String ibz5sample0003name;
    /**
     * 更新时间
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * IBZ5SAMPLE0003标识
     */
    @DEField(isKeyField=true)
    @TableId(value= "ibz5sample0003id",type=IdType.ASSIGN_UUID)
    @JSONField(name = "ibz5sample0003id")
    @JsonProperty("ibz5sample0003id")
    private String ibz5sample0003id;
    /**
     * 更新人
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * 建立时间
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * 建立人
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * 上级
     */
    @TableField(exist = false)
    @JSONField(name = "pibz5sample0003name")
    @JsonProperty("pibz5sample0003name")
    private String pibz5sample0003name;
    /**
     * IBZ5SAMPLE0003标识
     */
    @TableField(value = "pibz5sample0003id")
    @JSONField(name = "pibz5sample0003id")
    @JsonProperty("pibz5sample0003id")
    private String pibz5sample0003id;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private com.ibiz5.app.core.sample.domain.IBZ5Sample0003 pibz5sample0003;



    /**
     * 设置 [FIELD01]
     */
    public void setField01(String field01){
        this.field01 = field01 ;
        this.modify("field01",field01);
    }

    /**
     * 设置 [备注]
     */
    public void setMemo(String memo){
        this.memo = memo ;
        this.modify("memo",memo);
    }

    /**
     * 设置 [名称]
     */
    public void setIbz5sample0003name(String ibz5sample0003name){
        this.ibz5sample0003name = ibz5sample0003name ;
        this.modify("ibz5sample0003name",ibz5sample0003name);
    }

    /**
     * 设置 [IBZ5SAMPLE0003标识]
     */
    public void setPibz5sample0003id(String pibz5sample0003id){
        this.pibz5sample0003id = pibz5sample0003id ;
        this.modify("pibz5sample0003id",pibz5sample0003id);
    }


    /**
     * 复制当前对象数据到目标对象(粘贴重置)
     * @param targetEntity 目标数据对象
     * @param bIncEmpty  是否包括空值
     * @param <T>
     * @return
     */
    @Override
    public <T> T copyTo(T targetEntity, boolean bIncEmpty) {
        this.reset("ibz5sample0003id");
        return super.copyTo(targetEntity,bIncEmpty);
    }
}


