package com.ibiz5.app.core.sample.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import com.ibiz5.app.util.domain.EntityBase;
import com.ibiz5.app.util.annotation.DEField;
import com.ibiz5.app.util.enums.DEPredefinedFieldType;
import com.ibiz5.app.util.enums.DEFieldDefaultValueType;
import com.ibiz5.app.util.helper.DataObject;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;
import com.ibiz5.app.util.annotation.Audit;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import com.ibiz5.app.util.domain.EntityMP;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;

/**
 * 实体[自循环流程]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "T_IBZ5SAMPLE0008",resultMap = "IBZ5Sample0008ResultMap")
public class IBZ5Sample0008 extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 业务状态
     */
    @TableField(value = "ywstate")
    @JSONField(name = "ywstate")
    @JsonProperty("ywstate")
    private String ywstate;
    /**
     * 下一步处理人
     */
    @TableField(value = "nextperson")
    @JSONField(name = "nextperson")
    @JsonProperty("nextperson")
    private String nextperson;
    /**
     * 更新人
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * 自循环流程名称
     */
    @TableField(value = "ibz5sample0008name")
    @JSONField(name = "ibz5sample0008name")
    @JsonProperty("ibz5sample0008name")
    private String ibz5sample0008name;
    /**
     * 更新时间
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * 工作流实例
     */
    @TableField(value = "wfinstanceid")
    @JSONField(name = "wfinstanceid")
    @JsonProperty("wfinstanceid")
    private String wfinstanceid;
    /**
     * 自循环流程标识
     */
    @DEField(isKeyField=true)
    @TableId(value= "ibz5sample0008id",type=IdType.ASSIGN_UUID)
    @JSONField(name = "ibz5sample0008id")
    @JsonProperty("ibz5sample0008id")
    private String ibz5sample0008id;
    /**
     * 自循环步骤
     */
    @TableField(value = "wfstep")
    @JSONField(name = "wfstep")
    @JsonProperty("wfstep")
    private String wfstep;
    /**
     * 工作流版本
     */
    @TableField(value = "wfversion")
    @JSONField(name = "wfversion")
    @JsonProperty("wfversion")
    private String wfversion;
    /**
     * 建立时间
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * 建立人
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * 工作流步骤
     */
    @TableField(value = "wfstate")
    @JSONField(name = "wfstate")
    @JsonProperty("wfstate")
    private Integer wfstate;



    /**
     * 设置 [业务状态]
     */
    public void setYwstate(String ywstate){
        this.ywstate = ywstate ;
        this.modify("ywstate",ywstate);
    }

    /**
     * 设置 [下一步处理人]
     */
    public void setNextperson(String nextperson){
        this.nextperson = nextperson ;
        this.modify("nextperson",nextperson);
    }

    /**
     * 设置 [自循环流程名称]
     */
    public void setIbz5sample0008name(String ibz5sample0008name){
        this.ibz5sample0008name = ibz5sample0008name ;
        this.modify("ibz5sample0008name",ibz5sample0008name);
    }

    /**
     * 设置 [工作流实例]
     */
    public void setWfinstanceid(String wfinstanceid){
        this.wfinstanceid = wfinstanceid ;
        this.modify("wfinstanceid",wfinstanceid);
    }

    /**
     * 设置 [自循环步骤]
     */
    public void setWfstep(String wfstep){
        this.wfstep = wfstep ;
        this.modify("wfstep",wfstep);
    }

    /**
     * 设置 [工作流版本]
     */
    public void setWfversion(String wfversion){
        this.wfversion = wfversion ;
        this.modify("wfversion",wfversion);
    }

    /**
     * 设置 [工作流步骤]
     */
    public void setWfstate(Integer wfstate){
        this.wfstate = wfstate ;
        this.modify("wfstate",wfstate);
    }


    /**
     * 复制当前对象数据到目标对象(粘贴重置)
     * @param targetEntity 目标数据对象
     * @param bIncEmpty  是否包括空值
     * @param <T>
     * @return
     */
    @Override
    public <T> T copyTo(T targetEntity, boolean bIncEmpty) {
        this.reset("ibz5sample0008id");
        return super.copyTo(targetEntity,bIncEmpty);
    }
}


