package com.ibiz5.app.core.sample.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import com.ibiz5.app.util.domain.EntityBase;
import com.ibiz5.app.util.annotation.DEField;
import com.ibiz5.app.util.enums.DEPredefinedFieldType;
import com.ibiz5.app.util.enums.DEFieldDefaultValueType;
import com.ibiz5.app.util.helper.DataObject;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;
import com.ibiz5.app.util.annotation.Audit;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import com.ibiz5.app.util.domain.EntityMP;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;

/**
 * 实体[订单明细]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "T_IBZ5SAMPLE0011",resultMap = "IBZ5Sample0011ResultMap")
public class IBZ5Sample0011 extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 数量
     */
    @TableField(value = "quantity")
    @JSONField(name = "quantity")
    @JsonProperty("quantity")
    private Integer quantity;
    /**
     * 订单明细标识
     */
    @DEField(isKeyField=true)
    @TableId(value= "ibz5sample0011id",type=IdType.ASSIGN_UUID)
    @JSONField(name = "ibz5sample0011id")
    @JsonProperty("ibz5sample0011id")
    private String ibz5sample0011id;
    /**
     * 小计
     */
    @TableField(exist = false)
    @JSONField(name = "amount")
    @JsonProperty("amount")
    private Double amount;
    /**
     * 建立时间
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * 建立人
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * 更新时间
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * 更新人
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * 订单明细名称
     */
    @TableField(value = "ibz5sample0011name")
    @JSONField(name = "ibz5sample0011name")
    @JsonProperty("ibz5sample0011name")
    private String ibz5sample0011name;
    /**
     * 订单名称
     */
    @TableField(exist = false)
    @JSONField(name = "ibz5sample0010name")
    @JsonProperty("ibz5sample0010name")
    private String ibz5sample0010name;
    /**
     * 单位
     */
    @TableField(exist = false)
    @JSONField(name = "unit")
    @JsonProperty("unit")
    private String unit;
    /**
     * 统一产品名称
     */
    @TableField(exist = false)
    @JSONField(name = "ibz5uniproductname")
    @JsonProperty("ibz5uniproductname")
    private String ibz5uniproductname;
    /**
     * 单价
     */
    @TableField(exist = false)
    @JSONField(name = "unitprice")
    @JsonProperty("unitprice")
    private Double unitprice;
    /**
     * 统一产品标识
     */
    @TableField(value = "ibz5uniproductid")
    @JSONField(name = "ibz5uniproductid")
    @JsonProperty("ibz5uniproductid")
    private String ibz5uniproductid;
    /**
     * 订单标识
     */
    @TableField(value = "ibz5sample0010id")
    @JSONField(name = "ibz5sample0010id")
    @JsonProperty("ibz5sample0010id")
    private String ibz5sample0010id;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private com.ibiz5.app.core.sample.domain.IBZ5Sample0010 ibz5sample0010;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private com.ibiz5.app.core.sample.domain.IBZ5UNIProduct ibz5uniproduct;



    /**
     * 设置 [数量]
     */
    public void setQuantity(Integer quantity){
        this.quantity = quantity ;
        this.modify("quantity",quantity);
    }

    /**
     * 设置 [订单明细名称]
     */
    public void setIbz5sample0011name(String ibz5sample0011name){
        this.ibz5sample0011name = ibz5sample0011name ;
        this.modify("ibz5sample0011name",ibz5sample0011name);
    }

    /**
     * 设置 [统一产品标识]
     */
    public void setIbz5uniproductid(String ibz5uniproductid){
        this.ibz5uniproductid = ibz5uniproductid ;
        this.modify("ibz5uniproductid",ibz5uniproductid);
    }

    /**
     * 设置 [订单标识]
     */
    public void setIbz5sample0010id(String ibz5sample0010id){
        this.ibz5sample0010id = ibz5sample0010id ;
        this.modify("ibz5sample0010id",ibz5sample0010id);
    }


    /**
     * 复制当前对象数据到目标对象(粘贴重置)
     * @param targetEntity 目标数据对象
     * @param bIncEmpty  是否包括空值
     * @param <T>
     * @return
     */
    @Override
    public <T> T copyTo(T targetEntity, boolean bIncEmpty) {
        this.reset("ibz5sample0011id");
        return super.copyTo(targetEntity,bIncEmpty);
    }
}


