package com.ibiz5.app.core.sample.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import com.ibiz5.app.util.domain.EntityBase;
import com.ibiz5.app.util.annotation.DEField;
import com.ibiz5.app.util.enums.DEPredefinedFieldType;
import com.ibiz5.app.util.enums.DEFieldDefaultValueType;
import com.ibiz5.app.util.helper.DataObject;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;
import com.ibiz5.app.util.annotation.Audit;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import com.ibiz5.app.util.domain.EntityMP;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;

/**
 * 实体[员工]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "T_IBZ5SAMPLE0014",resultMap = "IBZ5Sample0014ResultMap")
public class IBZ5Sample0014 extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 员工编号
     */
    @TableField(value = "sn")
    @JSONField(name = "sn")
    @JsonProperty("sn")
    private String sn;
    /**
     * 更新时间
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * 员工标识
     */
    @DEField(isKeyField=true)
    @TableId(value= "ibz5sample0014id",type=IdType.ASSIGN_UUID)
    @JSONField(name = "ibz5sample0014id")
    @JsonProperty("ibz5sample0014id")
    private String ibz5sample0014id;
    /**
     * 建立时间
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * 建立人
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * 更新人
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * 员工名称
     */
    @TableField(value = "ibz5sample0014name")
    @JSONField(name = "ibz5sample0014name")
    @JsonProperty("ibz5sample0014name")
    private String ibz5sample0014name;
    /**
     * 名称
     */
    @TableField(exist = false)
    @JSONField(name = "ibz5sample0003name")
    @JsonProperty("ibz5sample0003name")
    private String ibz5sample0003name;
    /**
     * IBZ5SAMPLE0003标识
     */
    @TableField(value = "ibz5sample0003id")
    @JSONField(name = "ibz5sample0003id")
    @JsonProperty("ibz5sample0003id")
    private String ibz5sample0003id;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private com.ibiz5.app.core.sample.domain.IBZ5Sample0003 ibz5sample0003;



    /**
     * 设置 [员工编号]
     */
    public void setSn(String sn){
        this.sn = sn ;
        this.modify("sn",sn);
    }

    /**
     * 设置 [员工名称]
     */
    public void setIbz5sample0014name(String ibz5sample0014name){
        this.ibz5sample0014name = ibz5sample0014name ;
        this.modify("ibz5sample0014name",ibz5sample0014name);
    }

    /**
     * 设置 [IBZ5SAMPLE0003标识]
     */
    public void setIbz5sample0003id(String ibz5sample0003id){
        this.ibz5sample0003id = ibz5sample0003id ;
        this.modify("ibz5sample0003id",ibz5sample0003id);
    }


    /**
     * 复制当前对象数据到目标对象(粘贴重置)
     * @param targetEntity 目标数据对象
     * @param bIncEmpty  是否包括空值
     * @param <T>
     * @return
     */
    @Override
    public <T> T copyTo(T targetEntity, boolean bIncEmpty) {
        this.reset("ibz5sample0014id");
        return super.copyTo(targetEntity,bIncEmpty);
    }
}


