package com.ibiz5.app.core.sample.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import com.ibiz5.app.util.domain.EntityBase;
import com.ibiz5.app.util.annotation.DEField;
import com.ibiz5.app.util.enums.DEPredefinedFieldType;
import com.ibiz5.app.util.enums.DEFieldDefaultValueType;
import com.ibiz5.app.util.helper.DataObject;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;
import com.ibiz5.app.util.annotation.Audit;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import com.ibiz5.app.util.domain.EntityMP;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;

/**
 * 实体[员工]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "T_IBZ5SAMPLE0020",resultMap = "IBZ5Sample0020ResultMap")
public class IBZ5Sample0020 extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 员工标识
     */
    @DEField(isKeyField=true)
    @TableId(value= "ibz5sample0020id",type=IdType.ASSIGN_UUID)
    @JSONField(name = "ibz5sample0020id")
    @JsonProperty("ibz5sample0020id")
    private String ibz5sample0020id;
    /**
     * 更新人
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * 建立时间
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * 更新时间
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * 员工名称
     */
    @TableField(value = "ibz5sample0020name")
    @JSONField(name = "ibz5sample0020name")
    @JsonProperty("ibz5sample0020name")
    private String ibz5sample0020name;
    /**
     * 建立人
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * 部门名称
     */
    @TableField(value = "ibz5sample0019name")
    @JSONField(name = "ibz5sample0019name")
    @JsonProperty("ibz5sample0019name")
    private String ibz5sample0019name;
    /**
     * 部门id
     */
    @TableField(value = "ibz5sample0019id")
    @JSONField(name = "ibz5sample0019id")
    @JsonProperty("ibz5sample0019id")
    private String ibz5sample0019id;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private com.ibiz5.app.core.sample.domain.IBZ5Sample0019 ibz5sample0019;



    /**
     * 设置 [员工名称]
     */
    public void setIbz5sample0020name(String ibz5sample0020name){
        this.ibz5sample0020name = ibz5sample0020name ;
        this.modify("ibz5sample0020name",ibz5sample0020name);
    }

    /**
     * 设置 [部门名称]
     */
    public void setIbz5sample0019name(String ibz5sample0019name){
        this.ibz5sample0019name = ibz5sample0019name ;
        this.modify("ibz5sample0019name",ibz5sample0019name);
    }

    /**
     * 设置 [部门id]
     */
    public void setIbz5sample0019id(String ibz5sample0019id){
        this.ibz5sample0019id = ibz5sample0019id ;
        this.modify("ibz5sample0019id",ibz5sample0019id);
    }


    /**
     * 复制当前对象数据到目标对象(粘贴重置)
     * @param targetEntity 目标数据对象
     * @param bIncEmpty  是否包括空值
     * @param <T>
     * @return
     */
    @Override
    public <T> T copyTo(T targetEntity, boolean bIncEmpty) {
        this.reset("ibz5sample0020id");
        return super.copyTo(targetEntity,bIncEmpty);
    }
}


