package com.ibiz5.app.core.sample.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import com.ibiz5.app.util.domain.EntityBase;
import com.ibiz5.app.util.annotation.DEField;
import com.ibiz5.app.util.enums.DEPredefinedFieldType;
import com.ibiz5.app.util.enums.DEFieldDefaultValueType;
import com.ibiz5.app.util.helper.DataObject;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;
import com.ibiz5.app.util.annotation.Audit;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import com.ibiz5.app.util.domain.EntityMP;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;

/**
 * 实体[软件]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "T_IBZ5SOFTWARESUIT",resultMap = "IBZ5SoftwareSuitResultMap")
public class IBZ5SoftwareSuit extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 建立人
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * 软件标识
     */
    @DEField(isKeyField=true)
    @TableId(value= "ibz5softwaresuitid",type=IdType.ASSIGN_UUID)
    @JSONField(name = "ibz5softwaresuitid")
    @JsonProperty("ibz5softwaresuitid")
    private String ibz5softwaresuitid;
    /**
     * 更新时间
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * 更新人
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * 软件名称
     */
    @TableField(value = "ibz5softwaresuitname")
    @JSONField(name = "ibz5softwaresuitname")
    @JsonProperty("ibz5softwaresuitname")
    private String ibz5softwaresuitname;
    /**
     * 建立时间
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;



    /**
     * 设置 [软件名称]
     */
    public void setIbz5softwaresuitname(String ibz5softwaresuitname){
        this.ibz5softwaresuitname = ibz5softwaresuitname ;
        this.modify("ibz5softwaresuitname",ibz5softwaresuitname);
    }


    /**
     * 复制当前对象数据到目标对象(粘贴重置)
     * @param targetEntity 目标数据对象
     * @param bIncEmpty  是否包括空值
     * @param <T>
     * @return
     */
    @Override
    public <T> T copyTo(T targetEntity, boolean bIncEmpty) {
        this.reset("ibz5softwaresuitid");
        return super.copyTo(targetEntity,bIncEmpty);
    }
}


