package com.ibiz5.app.core.sample.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import com.ibiz5.app.util.domain.EntityBase;
import com.ibiz5.app.util.annotation.DEField;
import com.ibiz5.app.util.enums.DEPredefinedFieldType;
import com.ibiz5.app.util.enums.DEFieldDefaultValueType;
import com.ibiz5.app.util.helper.DataObject;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;
import com.ibiz5.app.util.annotation.Audit;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import com.ibiz5.app.util.domain.EntityMP;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;

/**
 * 实体[存储]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "T_IBZ5STORAGE",resultMap = "IBZ5StorageResultMap")
public class IBZ5Storage extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 分组类型
     */
    @TableField(exist = false)
    @JSONField(name = "ibz5hardwaretype")
    @JsonProperty("ibz5hardwaretype")
    private String ibz5hardwaretype;
    /**
     * 建立人
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * 存储标识
     */
    @DEField(isKeyField=true)
    @TableId(value= "ibz5storageid",type=IdType.ASSIGN_UUID)
    @JSONField(name = "ibz5storageid")
    @JsonProperty("ibz5storageid")
    private String ibz5storageid;
    /**
     * 建立时间
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * 生产厂商
     */
    @TableField(exist = false)
    @JSONField(name = "producer")
    @JsonProperty("producer")
    private String producer;
    /**
     * 产品编号
     */
    @TableField(exist = false)
    @JSONField(name = "productuid")
    @JsonProperty("productuid")
    private String productuid;
    /**
     * 更新人
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * 单位
     */
    @TableField(exist = false)
    @JSONField(name = "unit")
    @JsonProperty("unit")
    private String unit;
    /**
     * 存储名称
     */
    @TableField(value = "ibz5storagename")
    @JSONField(name = "ibz5storagename")
    @JsonProperty("ibz5storagename")
    private String ibz5storagename;
    /**
     * 更新时间
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * 单价
     */
    @TableField(exist = false)
    @JSONField(name = "unitprice")
    @JsonProperty("unitprice")
    private Double unitprice;



    /**
     * 设置 [存储名称]
     */
    public void setIbz5storagename(String ibz5storagename){
        this.ibz5storagename = ibz5storagename ;
        this.modify("ibz5storagename",ibz5storagename);
    }


    /**
     * 复制当前对象数据到目标对象(粘贴重置)
     * @param targetEntity 目标数据对象
     * @param bIncEmpty  是否包括空值
     * @param <T>
     * @return
     */
    @Override
    public <T> T copyTo(T targetEntity, boolean bIncEmpty) {
        this.reset("ibz5storageid");
        return super.copyTo(targetEntity,bIncEmpty);
    }
}


