package com.ibiz5.app.core.sample.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import com.ibiz5.app.util.domain.EntityBase;
import com.ibiz5.app.util.annotation.DEField;
import com.ibiz5.app.util.enums.DEPredefinedFieldType;
import com.ibiz5.app.util.enums.DEFieldDefaultValueType;
import com.ibiz5.app.util.helper.DataObject;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;
import com.ibiz5.app.util.annotation.Audit;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import com.ibiz5.app.util.domain.EntityMP;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;

/**
 * 实体[统一产品（索引主实体）]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "T_IBZ5UNIPRODUCT",resultMap = "IBZ5UNIProductResultMap")
public class IBZ5UNIProduct extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 产品名称
     */
    @TableField(value = "ibz5uniproductname")
    @JSONField(name = "ibz5uniproductname")
    @JsonProperty("ibz5uniproductname")
    private String ibz5uniproductname;
    /**
     * 分组类型
     */
    @TableField(value = "ibz5uniproducttype")
    @JSONField(name = "ibz5uniproducttype")
    @JsonProperty("ibz5uniproducttype")
    private String ibz5uniproducttype;
    /**
     * 统一产品标识
     */
    @DEField(isKeyField=true)
    @TableId(value= "ibz5uniproductid",type=IdType.ASSIGN_UUID)
    @JSONField(name = "ibz5uniproductid")
    @JsonProperty("ibz5uniproductid")
    private String ibz5uniproductid;
    /**
     * 更新人
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * 建立时间
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * 单位
     */
    @TableField(value = "unit")
    @JSONField(name = "unit")
    @JsonProperty("unit")
    private String unit;
    /**
     * 更新时间
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * 建立人
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * 单价
     */
    @TableField(value = "unitprice")
    @JSONField(name = "unitprice")
    @JsonProperty("unitprice")
    private Double unitprice;



    /**
     * 设置 [产品名称]
     */
    public void setIbz5uniproductname(String ibz5uniproductname){
        this.ibz5uniproductname = ibz5uniproductname ;
        this.modify("ibz5uniproductname",ibz5uniproductname);
    }

    /**
     * 设置 [分组类型]
     */
    public void setIbz5uniproducttype(String ibz5uniproducttype){
        this.ibz5uniproducttype = ibz5uniproducttype ;
        this.modify("ibz5uniproducttype",ibz5uniproducttype);
    }

    /**
     * 设置 [单位]
     */
    public void setUnit(String unit){
        this.unit = unit ;
        this.modify("unit",unit);
    }

    /**
     * 设置 [单价]
     */
    public void setUnitprice(Double unitprice){
        this.unitprice = unitprice ;
        this.modify("unitprice",unitprice);
    }


    /**
     * 复制当前对象数据到目标对象(粘贴重置)
     * @param targetEntity 目标数据对象
     * @param bIncEmpty  是否包括空值
     * @param <T>
     * @return
     */
    @Override
    public <T> T copyTo(T targetEntity, boolean bIncEmpty) {
        this.reset("ibz5uniproductid");
        return super.copyTo(targetEntity,bIncEmpty);
    }
}


