package com.ibiz5.app.core.sample.filter;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;

import lombok.*;
import lombok.extern.slf4j.Slf4j;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.alibaba.fastjson.annotation.JSONField;

import org.springframework.util.ObjectUtils;
import org.springframework.util.StringUtils;


import com.ibiz5.app.util.filter.QueryWrapperContext;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.ibiz5.app.core.sample.domain.IBZ5Account;
/**
 * 关系型数据实体[IBZ5Account] 查询条件对象
 */
@Slf4j
@Data
public class IBZ5AccountSearchContext extends QueryWrapperContext<IBZ5Account> {

	private String n_ibz5accountname_like;//[账户名称]
	public void setN_ibz5accountname_like(String n_ibz5accountname_like) {
        this.n_ibz5accountname_like = n_ibz5accountname_like;
        if(!ObjectUtils.isEmpty(this.n_ibz5accountname_like)){
            this.getSearchCond().like("ibz5accountname", n_ibz5accountname_like);
        }
    }
	private String n_ibz5accountid_eq;//[账户标识]
	public void setN_ibz5accountid_eq(String n_ibz5accountid_eq) {
        this.n_ibz5accountid_eq = n_ibz5accountid_eq;
        if(!ObjectUtils.isEmpty(this.n_ibz5accountid_eq)){
            this.getSearchCond().eq("ibz5accountid", n_ibz5accountid_eq);
        }
    }

    /**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
            this.getSearchCond().and( wrapper ->
                     wrapper.like("ibz5accountname", query)   
            );
		 }
	}
}



