package com.ibiz5.app.core.sample.filter;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;

import lombok.*;
import lombok.extern.slf4j.Slf4j;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.alibaba.fastjson.annotation.JSONField;

import org.springframework.util.ObjectUtils;
import org.springframework.util.StringUtils;


import com.ibiz5.app.util.filter.QueryWrapperContext;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.ibiz5.app.core.sample.domain.IBZ5Hardware;
/**
 * 关系型数据实体[IBZ5Hardware] 查询条件对象
 */
@Slf4j
@Data
public class IBZ5HardwareSearchContext extends QueryWrapperContext<IBZ5Hardware> {

	private String n_ibz5hardwaretype_eq;//[分组类型]
	public void setN_ibz5hardwaretype_eq(String n_ibz5hardwaretype_eq) {
        this.n_ibz5hardwaretype_eq = n_ibz5hardwaretype_eq;
        if(!ObjectUtils.isEmpty(this.n_ibz5hardwaretype_eq)){
            this.getSearchCond().eq("ibz5hardwaretype", n_ibz5hardwaretype_eq);
        }
    }
	private String n_ibz5hardwarename_like;//[名称]
	public void setN_ibz5hardwarename_like(String n_ibz5hardwarename_like) {
        this.n_ibz5hardwarename_like = n_ibz5hardwarename_like;
        if(!ObjectUtils.isEmpty(this.n_ibz5hardwarename_like)){
            this.getSearchCond().like("ibz5hardwarename", n_ibz5hardwarename_like);
        }
    }

    /**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
            this.getSearchCond().and( wrapper ->
                     wrapper.like("ibz5hardwarename", query)   
            );
		 }
	}
}



