package com.ibiz5.app.core.sample.filter;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;

import lombok.*;
import lombok.extern.slf4j.Slf4j;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.alibaba.fastjson.annotation.JSONField;

import org.springframework.util.ObjectUtils;
import org.springframework.util.StringUtils;


import com.ibiz5.app.util.filter.QueryWrapperContext;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.ibiz5.app.core.sample.domain.IBZ5OrderDetail;
/**
 * 关系型数据实体[IBZ5OrderDetail] 查询条件对象
 */
@Slf4j
@Data
public class IBZ5OrderDetailSearchContext extends QueryWrapperContext<IBZ5OrderDetail> {

	private String n_ibz5orderdetailname_like;//[订单明细名称]
	public void setN_ibz5orderdetailname_like(String n_ibz5orderdetailname_like) {
        this.n_ibz5orderdetailname_like = n_ibz5orderdetailname_like;
        if(!ObjectUtils.isEmpty(this.n_ibz5orderdetailname_like)){
            this.getSearchCond().like("ibz5orderdetailname", n_ibz5orderdetailname_like);
        }
    }
	private String n_ibz5uniproductname_eq;//[产品名称]
	public void setN_ibz5uniproductname_eq(String n_ibz5uniproductname_eq) {
        this.n_ibz5uniproductname_eq = n_ibz5uniproductname_eq;
        if(!ObjectUtils.isEmpty(this.n_ibz5uniproductname_eq)){
            this.getSearchCond().eq("ibz5uniproductname", n_ibz5uniproductname_eq);
        }
    }
	private String n_ibz5uniproductname_like;//[产品名称]
	public void setN_ibz5uniproductname_like(String n_ibz5uniproductname_like) {
        this.n_ibz5uniproductname_like = n_ibz5uniproductname_like;
        if(!ObjectUtils.isEmpty(this.n_ibz5uniproductname_like)){
            this.getSearchCond().like("ibz5uniproductname", n_ibz5uniproductname_like);
        }
    }
	private String n_ibz5ordername_eq;//[订单名称]
	public void setN_ibz5ordername_eq(String n_ibz5ordername_eq) {
        this.n_ibz5ordername_eq = n_ibz5ordername_eq;
        if(!ObjectUtils.isEmpty(this.n_ibz5ordername_eq)){
            this.getSearchCond().eq("ibz5ordername", n_ibz5ordername_eq);
        }
    }
	private String n_ibz5ordername_like;//[订单名称]
	public void setN_ibz5ordername_like(String n_ibz5ordername_like) {
        this.n_ibz5ordername_like = n_ibz5ordername_like;
        if(!ObjectUtils.isEmpty(this.n_ibz5ordername_like)){
            this.getSearchCond().like("ibz5ordername", n_ibz5ordername_like);
        }
    }
	private String n_ibz5uniproductid_eq;//[统一产品标识]
	public void setN_ibz5uniproductid_eq(String n_ibz5uniproductid_eq) {
        this.n_ibz5uniproductid_eq = n_ibz5uniproductid_eq;
        if(!ObjectUtils.isEmpty(this.n_ibz5uniproductid_eq)){
            this.getSearchCond().eq("ibz5uniproductid", n_ibz5uniproductid_eq);
        }
    }
	private String n_ibz5orderid_eq;//[订单标识]
	public void setN_ibz5orderid_eq(String n_ibz5orderid_eq) {
        this.n_ibz5orderid_eq = n_ibz5orderid_eq;
        if(!ObjectUtils.isEmpty(this.n_ibz5orderid_eq)){
            this.getSearchCond().eq("ibz5orderid", n_ibz5orderid_eq);
        }
    }

    /**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
            this.getSearchCond().and( wrapper ->
                     wrapper.like("ibz5orderdetailname", query)   
            );
		 }
	}
}



