package com.ibiz5.app.core.sample.filter;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;

import lombok.*;
import lombok.extern.slf4j.Slf4j;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.alibaba.fastjson.annotation.JSONField;

import org.springframework.util.ObjectUtils;
import org.springframework.util.StringUtils;


import com.ibiz5.app.util.filter.QueryWrapperContext;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.ibiz5.app.core.sample.domain.IBZ5Order;
/**
 * 关系型数据实体[IBZ5Order] 查询条件对象
 */
@Slf4j
@Data
public class IBZ5OrderSearchContext extends QueryWrapperContext<IBZ5Order> {

	private String n_ibz5ordername_like;//[订单名称]
	public void setN_ibz5ordername_like(String n_ibz5ordername_like) {
        this.n_ibz5ordername_like = n_ibz5ordername_like;
        if(!ObjectUtils.isEmpty(this.n_ibz5ordername_like)){
            this.getSearchCond().like("ibz5ordername", n_ibz5ordername_like);
        }
    }
	private String n_wfstep_eq;//[工作流步骤]
	public void setN_wfstep_eq(String n_wfstep_eq) {
        this.n_wfstep_eq = n_wfstep_eq;
        if(!ObjectUtils.isEmpty(this.n_wfstep_eq)){
            this.getSearchCond().eq("wfstep", n_wfstep_eq);
        }
    }
    @JsonFormat(pattern="yyyy-MM-dd", timezone="GMT+8")
    @JSONField(format="yyyy-MM-dd")
	private Timestamp n_ordertime_gt;//[订单时间]
	public void setN_ordertime_gt(Timestamp n_ordertime_gt) {
        this.n_ordertime_gt = n_ordertime_gt;
        if(!ObjectUtils.isEmpty(this.n_ordertime_gt)){
            this.getSearchCond().gt("ordertime", n_ordertime_gt);
        }
    }
    @JsonFormat(pattern="yyyy-MM-dd", timezone="GMT+8")
    @JSONField(format="yyyy-MM-dd")
	private Timestamp n_ordertime_gtandeq;//[订单时间]
	public void setN_ordertime_gtandeq(Timestamp n_ordertime_gtandeq) {
        this.n_ordertime_gtandeq = n_ordertime_gtandeq;
        if(!ObjectUtils.isEmpty(this.n_ordertime_gtandeq)){
            this.getSearchCond().ge("ordertime", n_ordertime_gtandeq);
        }
    }
    @JsonFormat(pattern="yyyy-MM-dd", timezone="GMT+8")
    @JSONField(format="yyyy-MM-dd")
	private Timestamp n_ordertime_lt;//[订单时间]
	public void setN_ordertime_lt(Timestamp n_ordertime_lt) {
        this.n_ordertime_lt = n_ordertime_lt;
        if(!ObjectUtils.isEmpty(this.n_ordertime_lt)){
            this.getSearchCond().lt("ordertime", n_ordertime_lt);
        }
    }
    @JsonFormat(pattern="yyyy-MM-dd", timezone="GMT+8")
    @JSONField(format="yyyy-MM-dd")
	private Timestamp n_ordertime_ltandeq;//[订单时间]
	public void setN_ordertime_ltandeq(Timestamp n_ordertime_ltandeq) {
        this.n_ordertime_ltandeq = n_ordertime_ltandeq;
        if(!ObjectUtils.isEmpty(this.n_ordertime_ltandeq)){
            this.getSearchCond().le("ordertime", n_ordertime_ltandeq);
        }
    }
	private String n_orderstate_eq;//[订单状态]
	public void setN_orderstate_eq(String n_orderstate_eq) {
        this.n_orderstate_eq = n_orderstate_eq;
        if(!ObjectUtils.isEmpty(this.n_orderstate_eq)){
            this.getSearchCond().eq("orderstate", n_orderstate_eq);
        }
    }
	private String n_ordertype_eq;//[订单类型]
	public void setN_ordertype_eq(String n_ordertype_eq) {
        this.n_ordertype_eq = n_ordertype_eq;
        if(!ObjectUtils.isEmpty(this.n_ordertype_eq)){
            this.getSearchCond().eq("ordertype", n_ordertype_eq);
        }
    }
	private String n_ibz5customername_eq;//[客户名称]
	public void setN_ibz5customername_eq(String n_ibz5customername_eq) {
        this.n_ibz5customername_eq = n_ibz5customername_eq;
        if(!ObjectUtils.isEmpty(this.n_ibz5customername_eq)){
            this.getSearchCond().eq("ibz5customername", n_ibz5customername_eq);
        }
    }
	private String n_ibz5customername_like;//[客户名称]
	public void setN_ibz5customername_like(String n_ibz5customername_like) {
        this.n_ibz5customername_like = n_ibz5customername_like;
        if(!ObjectUtils.isEmpty(this.n_ibz5customername_like)){
            this.getSearchCond().like("ibz5customername", n_ibz5customername_like);
        }
    }
	private String n_ibz5customerid_eq;//[客户标识]
	public void setN_ibz5customerid_eq(String n_ibz5customerid_eq) {
        this.n_ibz5customerid_eq = n_ibz5customerid_eq;
        if(!ObjectUtils.isEmpty(this.n_ibz5customerid_eq)){
            this.getSearchCond().eq("ibz5customerid", n_ibz5customerid_eq);
        }
    }

    /**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
            this.getSearchCond().and( wrapper ->
                     wrapper.like("ibz5ordername", query)   
            );
		 }
	}
}



