package com.ibiz5.app.core.sample.filter;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;

import lombok.*;
import lombok.extern.slf4j.Slf4j;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.alibaba.fastjson.annotation.JSONField;

import org.springframework.util.ObjectUtils;
import org.springframework.util.StringUtils;


import com.ibiz5.app.util.filter.QueryWrapperContext;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.ibiz5.app.core.sample.domain.IBZ5Sample0003;
/**
 * 关系型数据实体[IBZ5Sample0003] 查询条件对象
 */
@Slf4j
@Data
public class IBZ5Sample0003SearchContext extends QueryWrapperContext<IBZ5Sample0003> {

	private String n_ibz5sample0003name_like;//[名称]
	public void setN_ibz5sample0003name_like(String n_ibz5sample0003name_like) {
        this.n_ibz5sample0003name_like = n_ibz5sample0003name_like;
        if(!ObjectUtils.isEmpty(this.n_ibz5sample0003name_like)){
            this.getSearchCond().like("ibz5sample0003name", n_ibz5sample0003name_like);
        }
    }
	private String n_pibz5sample0003name_eq;//[上级]
	public void setN_pibz5sample0003name_eq(String n_pibz5sample0003name_eq) {
        this.n_pibz5sample0003name_eq = n_pibz5sample0003name_eq;
        if(!ObjectUtils.isEmpty(this.n_pibz5sample0003name_eq)){
            this.getSearchCond().eq("pibz5sample0003name", n_pibz5sample0003name_eq);
        }
    }
	private String n_pibz5sample0003name_like;//[上级]
	public void setN_pibz5sample0003name_like(String n_pibz5sample0003name_like) {
        this.n_pibz5sample0003name_like = n_pibz5sample0003name_like;
        if(!ObjectUtils.isEmpty(this.n_pibz5sample0003name_like)){
            this.getSearchCond().like("pibz5sample0003name", n_pibz5sample0003name_like);
        }
    }
	private String n_pibz5sample0003id_eq;//[IBZ5SAMPLE0003标识]
	public void setN_pibz5sample0003id_eq(String n_pibz5sample0003id_eq) {
        this.n_pibz5sample0003id_eq = n_pibz5sample0003id_eq;
        if(!ObjectUtils.isEmpty(this.n_pibz5sample0003id_eq)){
            this.getSearchCond().eq("pibz5sample0003id", n_pibz5sample0003id_eq);
        }
    }

    /**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
            this.getSearchCond().and( wrapper ->
                     wrapper.like("ibz5sample0003name", query)   
            );
		 }
	}
}



