package com.ibiz5.app.core.sample.filter;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;

import lombok.*;
import lombok.extern.slf4j.Slf4j;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.alibaba.fastjson.annotation.JSONField;

import org.springframework.util.ObjectUtils;
import org.springframework.util.StringUtils;


import com.ibiz5.app.util.filter.QueryWrapperContext;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.ibiz5.app.core.sample.domain.IBZ5Sample0008;
/**
 * 关系型数据实体[IBZ5Sample0008] 查询条件对象
 */
@Slf4j
@Data
public class IBZ5Sample0008SearchContext extends QueryWrapperContext<IBZ5Sample0008> {

	private String n_ywstate_eq;//[业务状态]
	public void setN_ywstate_eq(String n_ywstate_eq) {
        this.n_ywstate_eq = n_ywstate_eq;
        if(!ObjectUtils.isEmpty(this.n_ywstate_eq)){
            this.getSearchCond().eq("ywstate", n_ywstate_eq);
        }
    }
	private String n_ibz5sample0008name_like;//[自循环流程名称]
	public void setN_ibz5sample0008name_like(String n_ibz5sample0008name_like) {
        this.n_ibz5sample0008name_like = n_ibz5sample0008name_like;
        if(!ObjectUtils.isEmpty(this.n_ibz5sample0008name_like)){
            this.getSearchCond().like("ibz5sample0008name", n_ibz5sample0008name_like);
        }
    }
	private String n_wfstep_eq;//[自循环步骤]
	public void setN_wfstep_eq(String n_wfstep_eq) {
        this.n_wfstep_eq = n_wfstep_eq;
        if(!ObjectUtils.isEmpty(this.n_wfstep_eq)){
            this.getSearchCond().eq("wfstep", n_wfstep_eq);
        }
    }

    /**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
            this.getSearchCond().and( wrapper ->
                     wrapper.like("ibz5sample0008name", query)   
            );
		 }
	}
}



