package com.ibiz5.app.core.sample.filter;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;

import lombok.*;
import lombok.extern.slf4j.Slf4j;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.alibaba.fastjson.annotation.JSONField;

import org.springframework.util.ObjectUtils;
import org.springframework.util.StringUtils;


import com.ibiz5.app.util.filter.QueryWrapperContext;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.ibiz5.app.core.sample.domain.IBZ5Sample0016;
/**
 * 关系型数据实体[IBZ5Sample0016] 查询条件对象
 */
@Slf4j
@Data
public class IBZ5Sample0016SearchContext extends QueryWrapperContext<IBZ5Sample0016> {

	private String n_ibz5sample0016name_like;//[项目成员名称]
	public void setN_ibz5sample0016name_like(String n_ibz5sample0016name_like) {
        this.n_ibz5sample0016name_like = n_ibz5sample0016name_like;
        if(!ObjectUtils.isEmpty(this.n_ibz5sample0016name_like)){
            this.getSearchCond().like("ibz5sample0016name", n_ibz5sample0016name_like);
        }
    }
	private String n_ibz5sample0014name_eq;//[员工名称]
	public void setN_ibz5sample0014name_eq(String n_ibz5sample0014name_eq) {
        this.n_ibz5sample0014name_eq = n_ibz5sample0014name_eq;
        if(!ObjectUtils.isEmpty(this.n_ibz5sample0014name_eq)){
            this.getSearchCond().eq("ibz5sample0014name", n_ibz5sample0014name_eq);
        }
    }
	private String n_ibz5sample0014name_like;//[员工名称]
	public void setN_ibz5sample0014name_like(String n_ibz5sample0014name_like) {
        this.n_ibz5sample0014name_like = n_ibz5sample0014name_like;
        if(!ObjectUtils.isEmpty(this.n_ibz5sample0014name_like)){
            this.getSearchCond().like("ibz5sample0014name", n_ibz5sample0014name_like);
        }
    }
	private String n_ibz5sample0015name_eq;//[项目名称]
	public void setN_ibz5sample0015name_eq(String n_ibz5sample0015name_eq) {
        this.n_ibz5sample0015name_eq = n_ibz5sample0015name_eq;
        if(!ObjectUtils.isEmpty(this.n_ibz5sample0015name_eq)){
            this.getSearchCond().eq("ibz5sample0015name", n_ibz5sample0015name_eq);
        }
    }
	private String n_ibz5sample0015name_like;//[项目名称]
	public void setN_ibz5sample0015name_like(String n_ibz5sample0015name_like) {
        this.n_ibz5sample0015name_like = n_ibz5sample0015name_like;
        if(!ObjectUtils.isEmpty(this.n_ibz5sample0015name_like)){
            this.getSearchCond().like("ibz5sample0015name", n_ibz5sample0015name_like);
        }
    }
	private String n_ibz5sample0015id_eq;//[项目标识]
	public void setN_ibz5sample0015id_eq(String n_ibz5sample0015id_eq) {
        this.n_ibz5sample0015id_eq = n_ibz5sample0015id_eq;
        if(!ObjectUtils.isEmpty(this.n_ibz5sample0015id_eq)){
            this.getSearchCond().eq("ibz5sample0015id", n_ibz5sample0015id_eq);
        }
    }
	private String n_ibz5sample0014id_eq;//[员工标识]
	public void setN_ibz5sample0014id_eq(String n_ibz5sample0014id_eq) {
        this.n_ibz5sample0014id_eq = n_ibz5sample0014id_eq;
        if(!ObjectUtils.isEmpty(this.n_ibz5sample0014id_eq)){
            this.getSearchCond().eq("ibz5sample0014id", n_ibz5sample0014id_eq);
        }
    }

    /**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
            this.getSearchCond().and( wrapper ->
                     wrapper.like("ibz5sample0016name", query)   
            );
		 }
	}
}



