package com.ibiz5.app.core.sample.filter;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;

import lombok.*;
import lombok.extern.slf4j.Slf4j;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.alibaba.fastjson.annotation.JSONField;

import org.springframework.util.ObjectUtils;
import org.springframework.util.StringUtils;


import com.ibiz5.app.util.filter.QueryWrapperContext;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.ibiz5.app.core.sample.domain.IBZ5Sample;
/**
 * 关系型数据实体[IBZ5Sample] 查询条件对象
 */
@Slf4j
@Data
public class IBZ5SampleSearchContext extends QueryWrapperContext<IBZ5Sample> {

	private String n_sampletype_eq;//[示例类型]
	public void setN_sampletype_eq(String n_sampletype_eq) {
        this.n_sampletype_eq = n_sampletype_eq;
        if(!ObjectUtils.isEmpty(this.n_sampletype_eq)){
            this.getSearchCond().eq("sampletype", n_sampletype_eq);
        }
    }
	private String n_ibz5sampleid_like;//[示例数据库标识]
	public void setN_ibz5sampleid_like(String n_ibz5sampleid_like) {
        this.n_ibz5sampleid_like = n_ibz5sampleid_like;
        if(!ObjectUtils.isEmpty(this.n_ibz5sampleid_like)){
            this.getSearchCond().like("ibz5sampleid", n_ibz5sampleid_like);
        }
    }
	private String n_ibz5samplename_like;//[示例数据库名称]
	public void setN_ibz5samplename_like(String n_ibz5samplename_like) {
        this.n_ibz5samplename_like = n_ibz5samplename_like;
        if(!ObjectUtils.isEmpty(this.n_ibz5samplename_like)){
            this.getSearchCond().like("ibz5samplename", n_ibz5samplename_like);
        }
    }

    /**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
            this.getSearchCond().and( wrapper ->
                     wrapper.like("ibz5samplename", query)   
            );
		 }
	}
}



