package com.ibiz5.app.core.sample.filter;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;

import lombok.*;
import lombok.extern.slf4j.Slf4j;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.alibaba.fastjson.annotation.JSONField;

import org.springframework.util.ObjectUtils;
import org.springframework.util.StringUtils;


import com.ibiz5.app.util.filter.QueryWrapperContext;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.ibiz5.app.core.sample.domain.IBZ5UNIProduct;
/**
 * 关系型数据实体[IBZ5UNIProduct] 查询条件对象
 */
@Slf4j
@Data
public class IBZ5UNIProductSearchContext extends QueryWrapperContext<IBZ5UNIProduct> {

	private String n_ibz5uniproductname_like;//[产品名称]
	public void setN_ibz5uniproductname_like(String n_ibz5uniproductname_like) {
        this.n_ibz5uniproductname_like = n_ibz5uniproductname_like;
        if(!ObjectUtils.isEmpty(this.n_ibz5uniproductname_like)){
            this.getSearchCond().like("ibz5uniproductname", n_ibz5uniproductname_like);
        }
    }
	private String n_ibz5uniproducttype_eq;//[分组类型]
	public void setN_ibz5uniproducttype_eq(String n_ibz5uniproducttype_eq) {
        this.n_ibz5uniproducttype_eq = n_ibz5uniproducttype_eq;
        if(!ObjectUtils.isEmpty(this.n_ibz5uniproducttype_eq)){
            this.getSearchCond().eq("ibz5uniproducttype", n_ibz5uniproducttype_eq);
        }
    }

    /**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
            this.getSearchCond().and( wrapper ->
                     wrapper.like("ibz5uniproductname", query)   
            );
		 }
	}
}



