package com.ibiz5.app.core.sample.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.HashMap;
import org.apache.ibatis.annotations.Select;
import com.ibiz5.app.core.sample.domain.IBZ5Customer_INTF;
import com.ibiz5.app.core.sample.filter.IBZ5Customer_INTFSearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.alibaba.fastjson.JSONObject;

public interface IBZ5Customer_INTFMapper extends BaseMapper<IBZ5Customer_INTF>{

    Page<IBZ5Customer_INTF> searchCurCustomer(IPage page, @Param("srf") IBZ5Customer_INTFSearchContext context, @Param("ew") Wrapper<IBZ5Customer_INTF> wrapper) ;
    Page<IBZ5Customer_INTF> searchDefault(IPage page, @Param("srf") IBZ5Customer_INTFSearchContext context, @Param("ew") Wrapper<IBZ5Customer_INTF> wrapper) ;
    @Override
    IBZ5Customer_INTF selectById(Serializable id);
    @Override
    int insert(IBZ5Customer_INTF entity);
    @Override
    int updateById(@Param(Constants.ENTITY) IBZ5Customer_INTF entity);
    @Override
    int update(@Param(Constants.ENTITY) IBZ5Customer_INTF entity, @Param("ew") Wrapper<IBZ5Customer_INTF> updateWrapper);
    @Override
    int deleteById(Serializable id);
     /**
      * 自定义查询SQL
      * @param sql
      * @return
      */
     @Select("${sql}")
     List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);

}
