package com.ibiz5.app.core.sample.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.HashMap;
import org.apache.ibatis.annotations.Select;
import com.ibiz5.app.core.sample.domain.IBZ5OrderDetail;
import com.ibiz5.app.core.sample.filter.IBZ5OrderDetailSearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.alibaba.fastjson.JSONObject;

public interface IBZ5OrderDetailMapper extends BaseMapper<IBZ5OrderDetail>{

    Page<IBZ5OrderDetail> searchCSMXDY(IPage page, @Param("srf") IBZ5OrderDetailSearchContext context, @Param("ew") Wrapper<IBZ5OrderDetail> wrapper) ;
    Page<IBZ5OrderDetail> searchDefault(IPage page, @Param("srf") IBZ5OrderDetailSearchContext context, @Param("ew") Wrapper<IBZ5OrderDetail> wrapper) ;
    Page<IBZ5OrderDetail> searchLOGIC_0007(IPage page, @Param("srf") IBZ5OrderDetailSearchContext context, @Param("ew") Wrapper<IBZ5OrderDetail> wrapper) ;
    Page<IBZ5OrderDetail> searchX(IPage page, @Param("srf") IBZ5OrderDetailSearchContext context, @Param("ew") Wrapper<IBZ5OrderDetail> wrapper) ;
    @Override
    IBZ5OrderDetail selectById(Serializable id);
    @Override
    int insert(IBZ5OrderDetail entity);
    @Override
    int updateById(@Param(Constants.ENTITY) IBZ5OrderDetail entity);
    @Override
    int update(@Param(Constants.ENTITY) IBZ5OrderDetail entity, @Param("ew") Wrapper<IBZ5OrderDetail> updateWrapper);
    @Override
    int deleteById(Serializable id);
     /**
      * 自定义查询SQL
      * @param sql
      * @return
      */
     @Select("${sql}")
     List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);

    List<IBZ5OrderDetail> selectByIbz5orderid(@Param("ibz5orderid") Serializable ibz5orderid) ;

    List<IBZ5OrderDetail> selectByIbz5uniproductid(@Param("ibz5uniproductid") Serializable ibz5uniproductid) ;

}
