package com.ibiz5.app.core.sample.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import com.ibiz5.app.core.sample.domain.IBZ5CPU;
import com.ibiz5.app.core.sample.filter.IBZ5CPUSearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[IBZ5CPU] 服务对象接口
 */
public interface IIBZ5CPUService extends IService<IBZ5CPU>{

    boolean create(IBZ5CPU et) ;
    void createBatch(List<IBZ5CPU> list) ;
    boolean update(IBZ5CPU et) ;
    void updateBatch(List<IBZ5CPU> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    IBZ5CPU get(String key) ;
    IBZ5CPU getDraft(IBZ5CPU et) ;
    boolean checkKey(IBZ5CPU et) ;
    boolean save(IBZ5CPU et) ;
    void saveBatch(List<IBZ5CPU> list) ;
    Page<IBZ5CPU> searchDefault(IBZ5CPUSearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<IBZ5CPU> getIbz5cpuByIds(List<String> ids) ;
    List<IBZ5CPU> getIbz5cpuByEntities(List<IBZ5CPU> entities) ;
}


