package com.ibiz5.app.core.sample.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import com.ibiz5.app.core.sample.domain.IBZ5CustomerMG;
import com.ibiz5.app.core.sample.filter.IBZ5CustomerMGSearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[IBZ5CustomerMG] 服务对象接口
 */
public interface IIBZ5CustomerMGService extends IService<IBZ5CustomerMG>{

    boolean create(IBZ5CustomerMG et) ;
    void createBatch(List<IBZ5CustomerMG> list) ;
    boolean update(IBZ5CustomerMG et) ;
    void updateBatch(List<IBZ5CustomerMG> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    IBZ5CustomerMG get(String key) ;
    IBZ5CustomerMG getDraft(IBZ5CustomerMG et) ;
    boolean checkKey(IBZ5CustomerMG et) ;
    boolean save(IBZ5CustomerMG et) ;
    void saveBatch(List<IBZ5CustomerMG> list) ;
    Page<IBZ5CustomerMG> searchDefault(IBZ5CustomerMGSearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


