package com.ibiz5.app.core.sample.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import com.ibiz5.app.core.sample.domain.IBZ5Customer_INTF;
import com.ibiz5.app.core.sample.filter.IBZ5Customer_INTFSearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[IBZ5Customer_INTF] 服务对象接口
 */
public interface IIBZ5Customer_INTFService extends IService<IBZ5Customer_INTF>{

    boolean create(IBZ5Customer_INTF et) ;
    void createBatch(List<IBZ5Customer_INTF> list) ;
    boolean update(IBZ5Customer_INTF et) ;
    void updateBatch(List<IBZ5Customer_INTF> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    IBZ5Customer_INTF get(String key) ;
    IBZ5Customer_INTF getDraft(IBZ5Customer_INTF et) ;
    boolean checkKey(IBZ5Customer_INTF et) ;
    boolean save(IBZ5Customer_INTF et) ;
    void saveBatch(List<IBZ5Customer_INTF> list) ;
    IBZ5Customer_INTF xXX(IBZ5Customer_INTF et) ;
    Page<IBZ5Customer_INTF> searchCurCustomer(IBZ5Customer_INTFSearchContext context) ;
    Page<IBZ5Customer_INTF> searchDefault(IBZ5Customer_INTFSearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<IBZ5Customer_INTF> getIbz5customerIntfByIds(List<String> ids) ;
    List<IBZ5Customer_INTF> getIbz5customerIntfByEntities(List<IBZ5Customer_INTF> entities) ;
}


