package com.ibiz5.app.core.sample.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import com.ibiz5.app.core.sample.domain.IBZ5OrderDetail;
import com.ibiz5.app.core.sample.filter.IBZ5OrderDetailSearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[IBZ5OrderDetail] 服务对象接口
 */
public interface IIBZ5OrderDetailService extends IService<IBZ5OrderDetail>{

    boolean create(IBZ5OrderDetail et) ;
    void createBatch(List<IBZ5OrderDetail> list) ;
    IBZ5OrderDetail createTemp(IBZ5OrderDetail et) ;
    IBZ5OrderDetail createTempMajor(IBZ5OrderDetail et) ;
    boolean update(IBZ5OrderDetail et) ;
    void updateBatch(List<IBZ5OrderDetail> list) ;
    IBZ5OrderDetail updateTemp(IBZ5OrderDetail et) ;
    IBZ5OrderDetail updateTempMajor(IBZ5OrderDetail et) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    IBZ5OrderDetail removeTemp(IBZ5OrderDetail et) ;
    IBZ5OrderDetail removeTempMajor(IBZ5OrderDetail et) ;
    IBZ5OrderDetail get(String key) ;
    IBZ5OrderDetail getTemp(IBZ5OrderDetail et) ;
    IBZ5OrderDetail getTempMajor(IBZ5OrderDetail et) ;
    IBZ5OrderDetail getDraft(IBZ5OrderDetail et) ;
    IBZ5OrderDetail getDraftTemp(IBZ5OrderDetail et) ;
    IBZ5OrderDetail getDraftTempMajor(IBZ5OrderDetail et) ;
    boolean checkKey(IBZ5OrderDetail et) ;
    IBZ5OrderDetail countMoney(IBZ5OrderDetail et) ;
    IBZ5OrderDetail getUnitAndPrice(IBZ5OrderDetail et) ;
    boolean save(IBZ5OrderDetail et) ;
    void saveBatch(List<IBZ5OrderDetail> list) ;
    Page<IBZ5OrderDetail> searchCSMXDY(IBZ5OrderDetailSearchContext context) ;
    Page<IBZ5OrderDetail> searchDefault(IBZ5OrderDetailSearchContext context) ;
    Page<IBZ5OrderDetail> searchLOGIC_0007(IBZ5OrderDetailSearchContext context) ;
    Page<IBZ5OrderDetail> searchX(IBZ5OrderDetailSearchContext context) ;
    List<IBZ5OrderDetail> selectByIbz5orderid(String ibz5orderid);
    List<IBZ5OrderDetail> selectByIbz5orderid(Collection<String> ids);
    void removeByIbz5orderid(String ibz5orderid);
    List<IBZ5OrderDetail> selectByIbz5uniproductid(String ibz5uniproductid);
    List<IBZ5OrderDetail> selectByIbz5uniproductid(Collection<String> ids);
    void removeByIbz5uniproductid(String ibz5uniproductid);
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<IBZ5OrderDetail> getIbz5orderdetailByIds(List<String> ids) ;
    List<IBZ5OrderDetail> getIbz5orderdetailByEntities(List<IBZ5OrderDetail> entities) ;
}


