package com.ibiz5.app.core.sample.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import com.ibiz5.app.core.sample.domain.IBZ5Order;
import com.ibiz5.app.core.sample.filter.IBZ5OrderSearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[IBZ5Order] 服务对象接口
 */
public interface IIBZ5OrderService extends IService<IBZ5Order>{

    boolean create(IBZ5Order et) ;
    void createBatch(List<IBZ5Order> list) ;
    IBZ5Order createTemp(IBZ5Order et) ;
    IBZ5Order createTempMajor(IBZ5Order et) ;
    boolean update(IBZ5Order et) ;
    void updateBatch(List<IBZ5Order> list) ;
    IBZ5Order updateTemp(IBZ5Order et) ;
    IBZ5Order updateTempMajor(IBZ5Order et) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    IBZ5Order removeTemp(IBZ5Order et) ;
    IBZ5Order removeTempMajor(IBZ5Order et) ;
    IBZ5Order get(String key) ;
    IBZ5Order getTemp(IBZ5Order et) ;
    IBZ5Order getTempMajor(IBZ5Order et) ;
    IBZ5Order getDraft(IBZ5Order et) ;
    IBZ5Order getDraftTemp(IBZ5Order et) ;
    IBZ5Order getDraftTempMajor(IBZ5Order et) ;
    IBZ5Order bUIAction(IBZ5Order et) ;
    boolean checkKey(IBZ5Order et) ;
    boolean save(IBZ5Order et) ;
    void saveBatch(List<IBZ5Order> list) ;
    Page<IBZ5Order> searchCSDY(IBZ5OrderSearchContext context) ;
    Page<IBZ5Order> searchCurState30(IBZ5OrderSearchContext context) ;
    Page<IBZ5Order> searchDDJETJBB(IBZ5OrderSearchContext context) ;
    Page<IBZ5Order> searchDDReport(IBZ5OrderSearchContext context) ;
    Page<IBZ5Order> searchDYDDMXSJY(IBZ5OrderSearchContext context) ;
    Page<IBZ5Order> searchDefault(IBZ5OrderSearchContext context) ;
    Page<IBZ5Order> searchEchartsDefaultDataSource(IBZ5OrderSearchContext context) ;
    Page<IBZ5Order> searchGaugeDataSource(IBZ5OrderSearchContext context) ;
    Page<IBZ5Order> searchGaugeDataSourceByTime(IBZ5OrderSearchContext context) ;
    Page<IBZ5Order> searchLOGIC_22(IBZ5OrderSearchContext context) ;
    Page<IBZ5Order> searchRadarDataSource(IBZ5OrderSearchContext context) ;
    Page<IBZ5Order> searchSHZOrder(IBZ5OrderSearchContext context) ;
    Page<IBZ5Order> searchState10(IBZ5OrderSearchContext context) ;
    Page<IBZ5Order> searchState30(IBZ5OrderSearchContext context) ;
    Page<IBZ5Order> searchState40(IBZ5OrderSearchContext context) ;
    Page<IBZ5Order> searchXECX(IBZ5OrderSearchContext context) ;
    List<IBZ5Order> selectByIbz5customerid(String ibz5customerid);
    void removeByIbz5customerid(String ibz5customerid);
    JSONObject importData(List<IBZ5Order> entities,int batchSize,boolean isIgnoreError);

    @Async("asyncExecutor")
    void asyncImportData(List<IBZ5Order> entities,int batchSize,boolean isIgnoreError);
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<IBZ5Order> getIbz5orderByIds(List<String> ids) ;
    List<IBZ5Order> getIbz5orderByEntities(List<IBZ5Order> entities) ;
}


