package com.ibiz5.app.core.sample.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import com.ibiz5.app.core.sample.domain.IBZ5Sample0005;
import com.ibiz5.app.core.sample.filter.IBZ5Sample0005SearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[IBZ5Sample0005] 服务对象接口
 */
public interface IIBZ5Sample0005Service extends IService<IBZ5Sample0005>{

    boolean create(IBZ5Sample0005 et) ;
    void createBatch(List<IBZ5Sample0005> list) ;
    boolean update(IBZ5Sample0005 et) ;
    void updateBatch(List<IBZ5Sample0005> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    IBZ5Sample0005 get(String key) ;
    IBZ5Sample0005 getDraft(IBZ5Sample0005 et) ;
    boolean checkKey(IBZ5Sample0005 et) ;
    boolean save(IBZ5Sample0005 et) ;
    void saveBatch(List<IBZ5Sample0005> list) ;
    Page<IBZ5Sample0005> searchDefault(IBZ5Sample0005SearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<IBZ5Sample0005> getIbz5sample0005ByIds(List<String> ids) ;
    List<IBZ5Sample0005> getIbz5sample0005ByEntities(List<IBZ5Sample0005> entities) ;
}


