package com.ibiz5.app.core.sample.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import com.ibiz5.app.core.sample.domain.IBZ5Sample0007;
import com.ibiz5.app.core.sample.filter.IBZ5Sample0007SearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[IBZ5Sample0007] 服务对象接口
 */
public interface IIBZ5Sample0007Service extends IService<IBZ5Sample0007>{

    boolean create(IBZ5Sample0007 et) ;
    void createBatch(List<IBZ5Sample0007> list) ;
    boolean update(IBZ5Sample0007 et) ;
    void updateBatch(List<IBZ5Sample0007> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    IBZ5Sample0007 get(String key) ;
    IBZ5Sample0007 getDraft(IBZ5Sample0007 et) ;
    boolean checkKey(IBZ5Sample0007 et) ;
    boolean save(IBZ5Sample0007 et) ;
    void saveBatch(List<IBZ5Sample0007> list) ;
    Page<IBZ5Sample0007> searchCurGW(IBZ5Sample0007SearchContext context) ;
    Page<IBZ5Sample0007> searchDefault(IBZ5Sample0007SearchContext context) ;
    List<IBZ5Sample0007> selectByIbz5sample0006id(String ibz5sample0006id);
    void resetByIbz5sample0006id(String ibz5sample0006id);
    void resetByIbz5sample0006id(Collection<String> ids);
    void removeByIbz5sample0006id(String ibz5sample0006id);
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<IBZ5Sample0007> getIbz5sample0007ByIds(List<String> ids) ;
    List<IBZ5Sample0007> getIbz5sample0007ByEntities(List<IBZ5Sample0007> entities) ;
}


