package com.ibiz5.app.core.sample.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import com.ibiz5.app.core.sample.domain.IBZ5Sample0014;
import com.ibiz5.app.core.sample.filter.IBZ5Sample0014SearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[IBZ5Sample0014] 服务对象接口
 */
public interface IIBZ5Sample0014Service extends IService<IBZ5Sample0014>{

    boolean create(IBZ5Sample0014 et) ;
    void createBatch(List<IBZ5Sample0014> list) ;
    boolean update(IBZ5Sample0014 et) ;
    void updateBatch(List<IBZ5Sample0014> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    IBZ5Sample0014 get(String key) ;
    IBZ5Sample0014 getDraft(IBZ5Sample0014 et) ;
    boolean checkKey(IBZ5Sample0014 et) ;
    boolean save(IBZ5Sample0014 et) ;
    void saveBatch(List<IBZ5Sample0014> list) ;
    Page<IBZ5Sample0014> searchCurIBZ5Sample0014(IBZ5Sample0014SearchContext context) ;
    Page<IBZ5Sample0014> searchDefault(IBZ5Sample0014SearchContext context) ;
    List<IBZ5Sample0014> selectByIbz5sample0003id(String ibz5sample0003id);
    void removeByIbz5sample0003id(String ibz5sample0003id);
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<IBZ5Sample0014> getIbz5sample0014ByIds(List<String> ids) ;
    List<IBZ5Sample0014> getIbz5sample0014ByEntities(List<IBZ5Sample0014> entities) ;
}


