package com.ibiz5.app.core.sample.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import com.ibiz5.app.core.sample.domain.IBZ5Sample;
import com.ibiz5.app.core.sample.filter.IBZ5SampleSearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[IBZ5Sample] 服务对象接口
 */
public interface IIBZ5SampleService extends IService<IBZ5Sample>{

    boolean create(IBZ5Sample et) ;
    void createBatch(List<IBZ5Sample> list) ;
    boolean update(IBZ5Sample et) ;
    void updateBatch(List<IBZ5Sample> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    IBZ5Sample get(String key) ;
    IBZ5Sample getDraft(IBZ5Sample et) ;
    boolean checkKey(IBZ5Sample et) ;
    boolean save(IBZ5Sample et) ;
    void saveBatch(List<IBZ5Sample> list) ;
    Page<IBZ5Sample> searchDefault(IBZ5SampleSearchContext context) ;
    Page<IBZ5Sample> searchFormType(IBZ5SampleSearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<IBZ5Sample> getIbz5sampleByIds(List<String> ids) ;
    List<IBZ5Sample> getIbz5sampleByEntities(List<IBZ5Sample> entities) ;
}


