package com.ibiz5.app.core.sample.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import com.ibiz5.app.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import com.ibiz5.app.core.sample.domain.IBZ5Sample0003;
import com.ibiz5.app.core.sample.filter.IBZ5Sample0003SearchContext;
import com.ibiz5.app.core.sample.service.IIBZ5Sample0003Service;

import com.ibiz5.app.util.helper.CachedBeanCopier;
import com.ibiz5.app.util.helper.DEFieldCacheMap;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ibiz5.app.core.sample.mapper.IBZ5Sample0003Mapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.alibaba.fastjson.JSONObject;
import org.springframework.util.StringUtils;

/**
 * 实体[示例实体03] 服务对象接口实现
 */
@Slf4j
@Service("IBZ5Sample0003ServiceImpl")
public class IBZ5Sample0003ServiceImpl extends ServiceImpl<IBZ5Sample0003Mapper, IBZ5Sample0003> implements IIBZ5Sample0003Service {


    protected com.ibiz5.app.core.sample.service.IIBZ5Sample0003Service ibz5sample0003Service = this;
    @Autowired
    @Lazy
    protected com.ibiz5.app.core.sample.service.IIBZ5Sample0014Service ibz5sample0014Service;

    protected int batchSize = 500;

    @Override
    @Transactional
    public boolean create(IBZ5Sample0003 et) {
        fillParentData(et);
        if(!this.retBool(this.baseMapper.insert(et)))
            return false;
        CachedBeanCopier.copy(get(et.getIbz5sample0003id()),et);
        return true;
    }

    @Override
    @Transactional
    public void createBatch(List<IBZ5Sample0003> list) {
        list.forEach(item->fillParentData(item));
        this.saveBatch(list,batchSize);
    }

    @Override
    @Transactional
    public boolean update(IBZ5Sample0003 et) {
        fillParentData(et);
         if(!update(et,(Wrapper) et.getUpdateWrapper(true).eq("ibz5sample0003id",et.getIbz5sample0003id())))
            return false;
        CachedBeanCopier.copy(get(et.getIbz5sample0003id()),et);
        return true;
    }

    @Override
    @Transactional
    public void updateBatch(List<IBZ5Sample0003> list) {
        list.forEach(item->fillParentData(item));
        updateBatchById(list,batchSize);
    }

    @Override
    @Transactional
    public boolean remove(String key) {
        ibz5sample0003Service.removeByPibz5sample0003id(key);
        boolean result=removeById(key);
        return result ;
    }

    @Override
    @Transactional
    public void removeBatch(Collection<String> idList) {
        ibz5sample0003Service.removeByPibz5sample0003id(idList);
        removeByIds(idList);
    }

    @Override
    @Transactional
    public IBZ5Sample0003 get(String key) {
        IBZ5Sample0003 et = getById(key);
        if(et==null){
            et=new IBZ5Sample0003();
            et.setIbz5sample0003id(key);
        }
        else{
        }
        return et;
    }

    @Override
    public IBZ5Sample0003 getDraft(IBZ5Sample0003 et) {
        fillParentData(et);
        return et;
    }

    @Override
    public boolean checkKey(IBZ5Sample0003 et) {
        return (!ObjectUtils.isEmpty(et.getIbz5sample0003id()))&&(!Objects.isNull(this.getById(et.getIbz5sample0003id())));
    }
    @Override
    @Transactional
    public boolean save(IBZ5Sample0003 et) {
        if(!saveOrUpdate(et))
            return false;
        return true;
    }

    @Override
    @Transactional
    public boolean saveOrUpdate(IBZ5Sample0003 et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? this.update(et) : this.create(et);
        }
    }

    @Override
    @Transactional
    public boolean saveBatch(Collection<IBZ5Sample0003> list) {
        list.forEach(item->fillParentData(item));
        saveOrUpdateBatch(list,batchSize);
        return true;
    }

    @Override
    @Transactional
    public void saveBatch(List<IBZ5Sample0003> list) {
        list.forEach(item->fillParentData(item));
        saveOrUpdateBatch(list,batchSize);
    }


	@Override
    public List<IBZ5Sample0003> selectByPibz5sample0003id(String ibz5sample0003id) {
        return baseMapper.selectByPibz5sample0003id(ibz5sample0003id);
    }
    @Override
    public void removeByPibz5sample0003id(Collection<String> ids) {
        this.remove(new QueryWrapper<IBZ5Sample0003>().in("pibz5sample0003id",ids));
    }

    @Override
    public void removeByPibz5sample0003id(String ibz5sample0003id) {
        this.remove(new QueryWrapper<IBZ5Sample0003>().eq("pibz5sample0003id",ibz5sample0003id));
    }


    /**
     * 查询集合 当前数据
     */
    @Override
    public Page<IBZ5Sample0003> searchCurData(IBZ5Sample0003SearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<IBZ5Sample0003> pages=baseMapper.searchCurData(context.getPages(),context,context.getSelectCond());
        return new PageImpl<IBZ5Sample0003>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }

    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<IBZ5Sample0003> searchDefault(IBZ5Sample0003SearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<IBZ5Sample0003> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
        return new PageImpl<IBZ5Sample0003>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }

    /**
     * 查询集合 顶级数据
     */
    @Override
    public Page<IBZ5Sample0003> searchTopData(IBZ5Sample0003SearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<IBZ5Sample0003> pages=baseMapper.searchTopData(context.getPages(),context,context.getSelectCond());
        return new PageImpl<IBZ5Sample0003>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }



    /**
     * 为当前实体填充父数据（外键值文本、外键值附加数据）
     * @param et
     */
    private void fillParentData(IBZ5Sample0003 et){
        //实体关系[DER1N_IBZ5SAMPLE0003_IBZ5SAMPLE0003_PIBZ5SAMPLE0003ID]
        if(!ObjectUtils.isEmpty(et.getPibz5sample0003id())){
            com.ibiz5.app.core.sample.domain.IBZ5Sample0003 pibz5sample0003=et.getPibz5sample0003();
            if(ObjectUtils.isEmpty(pibz5sample0003)){
                com.ibiz5.app.core.sample.domain.IBZ5Sample0003 majorEntity=ibz5sample0003Service.get(et.getPibz5sample0003id());
                et.setPibz5sample0003(majorEntity);
                pibz5sample0003=majorEntity;
            }
            et.setPibz5sample0003name(pibz5sample0003.getIbz5sample0003name());
        }
    }




    @Override
    public List<JSONObject> select(String sql, Map param){
        return this.baseMapper.selectBySQL(sql,param);
    }

    @Override
    @Transactional
    public boolean execute(String sql , Map param){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql,param);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }

    @Override
    public List<IBZ5Sample0003> getIbz5sample0003ByIds(List<String> ids) {
         return this.listByIds(ids);
    }

    @Override
    public List<IBZ5Sample0003> getIbz5sample0003ByEntities(List<IBZ5Sample0003> entities) {
        List ids =new ArrayList();
        for(IBZ5Sample0003 entity : entities){
            Serializable id=entity.getIbz5sample0003id();
            if(!ObjectUtils.isEmpty(id)){
                ids.add(id);
            }
        }
        if(ids.size()>0)
           return this.listByIds(ids);
        else
           return entities;
    }



}



