package com.ibiz5.app.core.sample.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import com.ibiz5.app.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import com.ibiz5.app.core.sample.domain.IBZ5Sample0016;
import com.ibiz5.app.core.sample.filter.IBZ5Sample0016SearchContext;
import com.ibiz5.app.core.sample.service.IIBZ5Sample0016Service;

import com.ibiz5.app.util.helper.CachedBeanCopier;
import com.ibiz5.app.util.helper.DEFieldCacheMap;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ibiz5.app.core.sample.mapper.IBZ5Sample0016Mapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.alibaba.fastjson.JSONObject;
import org.springframework.util.StringUtils;

/**
 * 实体[项目成员] 服务对象接口实现
 */
@Slf4j
@Service("IBZ5Sample0016ServiceImpl")
public class IBZ5Sample0016ServiceImpl extends ServiceImpl<IBZ5Sample0016Mapper, IBZ5Sample0016> implements IIBZ5Sample0016Service {

    @Autowired
    @Lazy
    protected com.ibiz5.app.core.sample.service.IIBZ5Sample0014Service ibz5sample0014Service;
    @Autowired
    @Lazy
    protected com.ibiz5.app.core.sample.service.IIBZ5Sample0015Service ibz5sample0015Service;

    protected int batchSize = 500;

    @Override
    @Transactional
    public boolean create(IBZ5Sample0016 et) {
        fillParentData(et);
        if(!this.retBool(this.baseMapper.insert(et)))
            return false;
        CachedBeanCopier.copy(get(et.getIbz5sample0016id()),et);
        return true;
    }

    @Override
    @Transactional
    public void createBatch(List<IBZ5Sample0016> list) {
        list.forEach(item->fillParentData(item));
        this.saveBatch(list,batchSize);
    }

    @Override
    @Transactional
    public boolean update(IBZ5Sample0016 et) {
        fillParentData(et);
         if(!update(et,(Wrapper) et.getUpdateWrapper(true).eq("ibz5sample0016id",et.getIbz5sample0016id())))
            return false;
        CachedBeanCopier.copy(get(et.getIbz5sample0016id()),et);
        return true;
    }

    @Override
    @Transactional
    public void updateBatch(List<IBZ5Sample0016> list) {
        list.forEach(item->fillParentData(item));
        updateBatchById(list,batchSize);
    }

    @Override
    @Transactional
    public boolean remove(String key) {
        boolean result=removeById(key);
        return result ;
    }

    @Override
    @Transactional
    public void removeBatch(Collection<String> idList) {
        removeByIds(idList);
    }

    @Override
    @Transactional
    public IBZ5Sample0016 get(String key) {
        IBZ5Sample0016 et = getById(key);
        if(et==null){
            et=new IBZ5Sample0016();
            et.setIbz5sample0016id(key);
        }
        else{
        }
        return et;
    }

    @Override
    public IBZ5Sample0016 getDraft(IBZ5Sample0016 et) {
        fillParentData(et);
        return et;
    }

    @Override
    public boolean checkKey(IBZ5Sample0016 et) {
        return (!ObjectUtils.isEmpty(et.getIbz5sample0016id()))&&(!Objects.isNull(this.getById(et.getIbz5sample0016id())));
    }
    @Override
    @Transactional
    public boolean save(IBZ5Sample0016 et) {
        if(!saveOrUpdate(et))
            return false;
        return true;
    }

    @Override
    @Transactional
    public boolean saveOrUpdate(IBZ5Sample0016 et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? this.update(et) : this.create(et);
        }
    }

    @Override
    @Transactional
    public boolean saveBatch(Collection<IBZ5Sample0016> list) {
        list.forEach(item->fillParentData(item));
        saveOrUpdateBatch(list,batchSize);
        return true;
    }

    @Override
    @Transactional
    public void saveBatch(List<IBZ5Sample0016> list) {
        list.forEach(item->fillParentData(item));
        saveOrUpdateBatch(list,batchSize);
    }


	@Override
    public List<IBZ5Sample0016> selectByIbz5sample0014id(String ibz5sample0014id) {
        return baseMapper.selectByIbz5sample0014id(ibz5sample0014id);
    }
    @Override
    public void resetByIbz5sample0014id(String ibz5sample0014id) {
        this.update(new UpdateWrapper<IBZ5Sample0016>().set("ibz5sample0014id",null).eq("ibz5sample0014id",ibz5sample0014id));
    }

    @Override
    public void resetByIbz5sample0014id(Collection<String> ids) {
        this.update(new UpdateWrapper<IBZ5Sample0016>().set("ibz5sample0014id",null).in("ibz5sample0014id",ids));
    }

    @Override
    public void removeByIbz5sample0014id(String ibz5sample0014id) {
        this.remove(new QueryWrapper<IBZ5Sample0016>().eq("ibz5sample0014id",ibz5sample0014id));
    }

	@Override
    public List<IBZ5Sample0016> selectByIbz5sample0015id(String ibz5sample0015id) {
        return baseMapper.selectByIbz5sample0015id(ibz5sample0015id);
    }
    @Override
    public void removeByIbz5sample0015id(String ibz5sample0015id) {
        this.remove(new QueryWrapper<IBZ5Sample0016>().eq("ibz5sample0015id",ibz5sample0015id));
    }


    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<IBZ5Sample0016> searchDefault(IBZ5Sample0016SearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<IBZ5Sample0016> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
        return new PageImpl<IBZ5Sample0016>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }



    /**
     * 为当前实体填充父数据（外键值文本、外键值附加数据）
     * @param et
     */
    private void fillParentData(IBZ5Sample0016 et){
        //实体关系[DER1N_IBZ5SAMPLE0016_IBZ5SAMPLE0014_IBZ5SAMPLE0014ID]
        if(!ObjectUtils.isEmpty(et.getIbz5sample0014id())){
            com.ibiz5.app.core.sample.domain.IBZ5Sample0014 ibz5sample0014=et.getIbz5sample0014();
            if(ObjectUtils.isEmpty(ibz5sample0014)){
                com.ibiz5.app.core.sample.domain.IBZ5Sample0014 majorEntity=ibz5sample0014Service.get(et.getIbz5sample0014id());
                et.setIbz5sample0014(majorEntity);
                ibz5sample0014=majorEntity;
            }
            et.setIbz5sample0014name(ibz5sample0014.getIbz5sample0014name());
        }
        //实体关系[DER1N_IBZ5SAMPLE0016_IBZ5SAMPLE0015_IBZ5SAMPLE0015ID]
        if(!ObjectUtils.isEmpty(et.getIbz5sample0015id())){
            com.ibiz5.app.core.sample.domain.IBZ5Sample0015 ibz5sample0015=et.getIbz5sample0015();
            if(ObjectUtils.isEmpty(ibz5sample0015)){
                com.ibiz5.app.core.sample.domain.IBZ5Sample0015 majorEntity=ibz5sample0015Service.get(et.getIbz5sample0015id());
                et.setIbz5sample0015(majorEntity);
                ibz5sample0015=majorEntity;
            }
            et.setIbz5sample0015name(ibz5sample0015.getIbz5sample0015name());
        }
    }




    @Override
    public List<JSONObject> select(String sql, Map param){
        return this.baseMapper.selectBySQL(sql,param);
    }

    @Override
    @Transactional
    public boolean execute(String sql , Map param){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql,param);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }

    @Override
    public List<IBZ5Sample0016> getIbz5sample0016ByIds(List<String> ids) {
         return this.listByIds(ids);
    }

    @Override
    public List<IBZ5Sample0016> getIbz5sample0016ByEntities(List<IBZ5Sample0016> entities) {
        List ids =new ArrayList();
        for(IBZ5Sample0016 entity : entities){
            Serializable id=entity.getIbz5sample0016id();
            if(!ObjectUtils.isEmpty(id)){
                ids.add(id);
            }
        }
        if(ids.size()>0)
           return this.listByIds(ids);
        else
           return entities;
    }



}



