package com.ibiz5.app.core.sample.service.logic.impl;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.kie.api.runtime.KieSession;
import org.kie.api.runtime.KieContainer;

import com.ibiz5.app.core.sample.service.logic.IIBZ5OrderDetailCountMoneyLogic;
import com.ibiz5.app.core.sample.domain.IBZ5OrderDetail;

/**
 * 关系型数据实体[CountMoney] 对象
 */
@Slf4j
@Service
public class IBZ5OrderDetailCountMoneyLogicImpl implements IIBZ5OrderDetailCountMoneyLogic{

    @Autowired
    private KieContainer kieContainer;


    @Autowired
    private com.ibiz5.app.core.sample.service.IIBZ5OrderDetailService iBzSysDefaultService;

    public com.ibiz5.app.core.sample.service.IIBZ5OrderDetailService getIBzSysDefaultService() {
        return this.iBzSysDefaultService;
    }

    public void execute(IBZ5OrderDetail et){

          KieSession kieSession = null;
        try{
           kieSession=kieContainer.newKieSession();
           kieSession.insert(et); 
           kieSession.setGlobal("ibz5orderdetailcountmoneydefault",et);
           kieSession.setGlobal("iBzSysIbz5orderdetailDefaultService",iBzSysDefaultService);
           kieSession.setGlobal("curuser", com.ibiz5.app.util.security.AuthenticationUser.getAuthenticationUser());
           kieSession.startProcess("com.ibiz5.app.core.sample.service.logic.ibz5orderdetailcountmoney");

        }catch(Exception e){
            throw new RuntimeException("执行[统计金额]处理逻辑发生异常"+e);
        }finally {
            if(kieSession!=null)
            kieSession.destroy();
        }
    }

}
