package com.ibiz5.app.core.sample.service.logic.impl;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.kie.api.runtime.KieSession;
import org.kie.api.runtime.KieContainer;

import com.ibiz5.app.core.sample.service.logic.IIBZ5OrderDetailGetUnitAndPriceLogic;
import com.ibiz5.app.core.sample.domain.IBZ5OrderDetail;

/**
 * 关系型数据实体[GetUnitAndPrice] 对象
 */
@Slf4j
@Service
public class IBZ5OrderDetailGetUnitAndPriceLogicImpl implements IIBZ5OrderDetailGetUnitAndPriceLogic{

    @Autowired
    private KieContainer kieContainer;

    @Autowired
    private com.ibiz5.app.core.sample.service.IIBZ5UNIProductService ibz5uniproductservice;

    public com.ibiz5.app.core.sample.service.IIBZ5UNIProductService getIbz5uniproductService() {
        return this.ibz5uniproductservice;
    }


    @Autowired
    private com.ibiz5.app.core.sample.service.IIBZ5OrderDetailService iBzSysDefaultService;

    public com.ibiz5.app.core.sample.service.IIBZ5OrderDetailService getIBzSysDefaultService() {
        return this.iBzSysDefaultService;
    }

    public void execute(IBZ5OrderDetail et){

          KieSession kieSession = null;
        try{
           kieSession=kieContainer.newKieSession();
           com.ibiz5.app.core.sample.domain.IBZ5UNIProduct  ibz5orderdetailgetunitandpriceproduct =new com.ibiz5.app.core.sample.domain.IBZ5UNIProduct();
           kieSession.insert(ibz5orderdetailgetunitandpriceproduct); 
           kieSession.setGlobal("ibz5orderdetailgetunitandpriceproduct",ibz5orderdetailgetunitandpriceproduct);
           kieSession.insert(et); 
           kieSession.setGlobal("ibz5orderdetailgetunitandpricedefault",et);
           kieSession.setGlobal("ibz5uniproductservice",ibz5uniproductservice);
           kieSession.setGlobal("iBzSysIbz5orderdetailDefaultService",iBzSysDefaultService);
           kieSession.setGlobal("curuser", com.ibiz5.app.util.security.AuthenticationUser.getAuthenticationUser());
           kieSession.startProcess("com.ibiz5.app.core.sample.service.logic.ibz5orderdetailgetunitandprice");

        }catch(Exception e){
            throw new RuntimeException("执行[通过商品ID获取单价及单位]处理逻辑发生异常"+e);
        }finally {
            if(kieSession!=null)
            kieSession.destroy();
        }
    }

}
