package com.ibiz5.app.core.sample.service.logic.impl;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.kie.api.runtime.KieSession;
import org.kie.api.runtime.KieContainer;

import com.ibiz5.app.core.sample.service.logic.IIBZ5Sample0019UpdateYGNameLogic;
import com.ibiz5.app.core.sample.domain.IBZ5Sample0019;

/**
 * 关系型数据实体[UpdateYGName] 对象
 */
@Slf4j
@Service
public class IBZ5Sample0019UpdateYGNameLogicImpl implements IIBZ5Sample0019UpdateYGNameLogic{

    @Autowired
    private KieContainer kieContainer;


    @Autowired
    private com.ibiz5.app.core.sample.service.IIBZ5Sample0019Service iBzSysDefaultService;

    public com.ibiz5.app.core.sample.service.IIBZ5Sample0019Service getIBzSysDefaultService() {
        return this.iBzSysDefaultService;
    }

    public void execute(IBZ5Sample0019 et){

          KieSession kieSession = null;
        try{
           kieSession=kieContainer.newKieSession();
           kieSession.insert(et); 
           kieSession.setGlobal("ibz5sample0019updateygnamedefault",et);
           kieSession.setGlobal("iBzSysIbz5sample0019DefaultService",iBzSysDefaultService);
           kieSession.setGlobal("curuser", com.ibiz5.app.util.security.AuthenticationUser.getAuthenticationUser());
           kieSession.startProcess("com.ibiz5.app.core.sample.service.logic.ibz5sample0019updateygname");

        }catch(Exception e){
            throw new RuntimeException("执行[更新员工名称]处理逻辑发生异常"+e);
        }finally {
            if(kieSession!=null)
            kieSession.destroy();
        }
    }

}
